----------------------------------------------------------
-- NAME : PROCEDURE ADDVATSALE_FROM_BILLREC
-- NOTE :         
-- CREATE : 25.04.01
-- RELEASE: 31.05.01
-- ALTER  : 13.01.2011 vsh -  .- '-'
-- ALTER  : 21.01.2011 vsh ''
----------------------------------------------------------
ALTER PROCEDURE ADDVATSALE_FROM_BILLREC
  @bill_id  T_IDENTIFIER,
  @vat_id   T_IDENTIFIER = NULL OUTPUT
-- WITH ENCRYPTION
AS 
declare @DocErr         int
declare @ENTERPRISE_ID  T_ENTERPRISE_ID
declare @AGREE_ID       T_IDENTIFIER
declare @DocId          T_IDENTIFIER
declare @tdoc           int
declare @CURR_HOME      T_CURRENCY_ID
declare @CURR_MAIN      T_CURRENCY_ID
declare @DOCUM_TAX_PROCENT     T_PROCENT
declare @DOCUM_DATE     datetime
declare @docum_numb     T_DOCUMENT_NUMB
DECLARE @AUTHOR_ID      T_AUTHOR

  EXEC GET_AUTHORID @AUTHOR_ID = @AUTHOR_ID OUTPUT
  SET @DocErr = 0
  SET @DocId = @vat_id
  SELECT
   @ENTERPRISE_ID     = ENTERPRISE_ID,
   @AGREE_ID          = AGREE_ID,
   @tdoc              = TDOC_ID,
   @CURR_HOME         = DOCUM_HOME_CURR,
   @CURR_MAIN         = DOCUM_MAIN_CURR,
   @DOCUM_TAX_PROCENT = DOCUM_TAX_PROCENT,
   @Docum_Date        = DOCUM_DATE ,
   @docum_numb        = docum_numb 
   FROM BILL_RECEIVE
   WHERE (DOCUM_ID = @bill_id) 

DECLARE @ds VARCHAR(40)
DECLARE @td VARCHAR(250)

SET DATEFORMAT dmy
IF @Docum_Date IS NOT NULL
  SET @ds = CONVERT(varchar, @Docum_Date, 104)
ELSE
  SET @ds = NULL

-- select @td = TDOC_NAME from type_doc where TDOC_ID = @tdoc
select @td = '-'

--    
declare @VATtype int

if(@DOCUM_TAX_PROCENT = 20) set @VATtype = 0
if(@DOCUM_TAX_PROCENT = 0) set @VATtype = 3

update INVOICE_TAX 
   set  ENTERPRISE_ID = @ENTERPRISE_ID,
        AGREE_ID      = @AGREE_ID,
        DOCUM_AUTHOR_ID = @AUTHOR_ID,
        INVTAX_TYPE     = @VATtype ,
        DOCUM_TAX_PROCENT = @DOCUM_TAX_PROCENT,
        DOCUM_BASIS = @td+'  '+rtrim(ltrim(@docum_numb))+'  '+@ds+ '.'
   where DOCUM_ID = @DocId

-- LINE 
DECLARE
 @tLINE_NUMBER                    INT,
 @tLINE_TYPE                      T_LINE_SP_TYPE,
 @tLINE_PLU_ID                    T_PLU,
 @tLINE_CNS_ID                    T_CONSIGNMENT,
 @tLINE_IN_OUT                    T_LINE_IN_OUT, 
 @tLINE_NAME                      T_NAME_LONG,
 @tLINE_UNIT                      T_METRIC_ID,
 @tLINE_QUAN                      T_DOCUMENT_QUAN,
 @tLINE_QUAN_DISTRIB              T_DOCUMENT_QUAN,
 @tLINE_LOC_ID                    T_LOCATION_ID,
 @tLINE_DEP_ID                    T_LOCATION_ID,
 @tLINE_SUBDEP_ID                 T_LOCATION_ID,
 @tLINE_SECT_ID                   T_LOCATION_ID,
 @tLINE_PRICE_HOME                T_COST       ,
 @tLINE_PRICEFULL_HOME            T_COST       ,
 @tLINE_DONE                      TINYINT

DECLARE DocLine_Cursor INSENSITIVE CURSOR FOR
    SELECT LINE_DONE,       LINE_TYPE,           LINE_PLU_ID,    LINE_CNS_ID,      LINE_IN_OUT,
           LINE_NAME,       LINE_UNIT,           LINE_QUAN,      LINE_QUAN_DISTRIB,
           LINE_LOC_ID,     LINE_DEP_ID,         LINE_SUBDEP_ID, LINE_SECT_ID,
           LINE_PRICE_HOME, LINE_PRICEFULL_HOME
    FROM LINE_BILL_RECEIVE
    WHERE DOCUM_ID = @bill_id
      AND LINE_TYPE != 2
      and LINE_PARENT_ID is null
    ORDER BY LINE_NUMBER

select @tLINE_NUMBER = isnull(max(LINE_NUMBER),0)
    from LINE_INVOICE_TAX 
    where DOCUM_ID = @DocId   
OPEN DocLine_Cursor
FETCH NEXT FROM DocLine_Cursor 
     INTO  @tLINE_DONE, @tLINE_TYPE, @tLINE_PLU_ID, @tLINE_CNS_ID, @tLINE_IN_OUT, @tLINE_NAME, @tLINE_UNIT,
           @tLINE_QUAN, @tLINE_QUAN_DISTRIB,
           @tLINE_LOC_ID, @tLINE_DEP_ID, @tLINE_SUBDEP_ID, @tLINE_SECT_ID,
           @tLINE_PRICE_HOME, @tLINE_PRICEFULL_HOME          
WHILE @@FETCH_STATUS = 0
BEGIN
  IF NOT EXISTS (
    SELECT LINE_PLU_ID
      FROM LINE_INVOICE_TAX
      WHERE ((DOCUM_ID = @DocId)
        and (LINE_PLU_ID = @tLINE_PLU_ID)
        and (LINE_PRICE_HOME =@tLINE_PRICE_HOME )))
    BEGIN
    SET @tLINE_NUMBER = @tLINE_NUMBER + 1
        INSERT INTO LINE_INVOICE_TAX ( 
             DOCUM_ID              , LINE_NUMBER           ,
             LINE_TYPE             , LINE_PLU_ID           ,
             LINE_IN_OUT           , LINE_NAME             ,
             LINE_UNIT             , LINE_QUAN             ,
             LINE_PRICE_HOME       , LINE_PRICEFULL_HOME   , 
             LINE_DONE          , LINE_LOC_ID           ,
             LINE_DEP_ID        , LINE_SUBDEP_ID        ,
             LINE_SECT_ID       , line_cns_id           )
        VALUES (
            @DocId,          @tLINE_NUMBER,
            @tLINE_TYPE,     @tLINE_PLU_ID,
            @tLINE_IN_OUT,   @tLINE_NAME, 
            @tLINE_UNIT,     @tLINE_QUAN, 
            isnull(@tLINE_PRICE_HOME,0), isnull(@tLINE_PRICEFULL_HOME,0),
            0,               @tLINE_LOC_ID,
            @tLINE_DEP_ID,   @tLINE_SUBDEP_ID,
            @tLINE_SECT_ID,  @tLINE_CNS_ID   )

    IF (@@ERROR <> 0) OR (@DocErr < 0)
      BEGIN
      SET @DocErr = 300 + @DocErr
      BREAK
      END
   END
   else                 
     UPDATE LINE_INVOICE_TAX set
             LINE_QUAN = LINE_QUAN + isnull(@tLINE_QUAN,0)         
          WHERE (DOCUM_ID = @DocId) 
            and (LINE_PLU_ID     = @tLINE_PLU_ID)
            and (LINE_PRICE_HOME = @tLINE_PRICE_HOME )

  FETCH NEXT FROM DocLine_Cursor 
     INTO  @tLINE_DONE, @tLINE_TYPE, @tLINE_PLU_ID, @tLINE_CNS_ID, @tLINE_IN_OUT, @tLINE_NAME, @tLINE_UNIT,
           @tLINE_QUAN, @tLINE_QUAN_DISTRIB,
           @tLINE_LOC_ID, @tLINE_DEP_ID, @tLINE_SUBDEP_ID, @tLINE_SECT_ID,
           @tLINE_PRICE_HOME, @tLINE_PRICEFULL_HOME
END
CLOSE DocLine_Cursor
DEALLOCATE DocLine_Cursor

exec @DocErr = CALC_SUMM_INVOICE_TAX
    @DOCUM_ID          = @DocId,
    @DOCUM_TAX_PROCENT = @DOCUM_TAX_PROCENT,
    @DOCUM_HOME_CURR   = @CURR_HOME,
    @DOCUM_MAIN_CURR   = @CURR_MAIN

IF (@@ERROR <> 0) OR (@DocErr <> 0)
      BEGIN
      SET @DocErr = 400 + @DocErr
      GOTO End_Of_Doc
      END

IF NOT EXISTS (
    SELECT LINE_PLU_ID
      FROM LINE_INVOICE_TAX
      WHERE DOCUM_ID = @DocId )
    BEGIN
    SET @DocErr = 9
    END
End_Of_Doc:

RETURN @DocErr
---------------------------------------------------------------------
GO

----------------------------------------------------------
-- NAME   : PROCEDURE MAKE_VATSALE_BY_SALE
-- NOTE   :  VATSALE  SALE
-- CREATE : 30.10.00 star
-- ALTER  : 11.01.05 star -   
-- ALTER  : 21.01.11 vsh  - '  '+ ltrim(rtrim(@Sale_Numb)) + '  ' + @ds + '.'
----------------------------------------------------------
ALTER PROCEDURE MAKE_VATSALE_BY_SALE
   @BILL_ID T_IDENTIFIER,
   @VAT_ID T_IDENTIFIER = NULL OUTPUT
-- WITH ENCRYPTION
AS 
declare @DocErr            int
declare @CURR_HOME         T_CURRENCY_ID
declare @CURR_MAIN         T_CURRENCY_ID
declare @NewId             int

declare @DocId             T_IDENTIFIER
declare @SELFENTER_ID      T_IDENTIFIER
declare @AGREE_ID          T_IDENTIFIER
declare @SUPPLIER_ID       T_ENTERPRISE_ID
declare @DOCUM_NUMB        T_DOCUMENT_NUMB
declare @DOCUM_NUMB_P      T_DOCUMENT_NUMB
declare @DOCUM_DATE        datetime
declare @DOCUM_TIME        datetime
declare @DocState          T_DOCUM_STATE
declare @PRECISION         int
declare @DOCUM_TAX_PROCENT T_PROCENT
declare @tdoc int 
DECLARE @DOC_EXT_RATE_TO_MAIN  T_CURRENCY_RATE,
        @DOC_EXT_RATE_TO_HOME  T_CURRENCY_RATE

  SET @DocErr = 0

-- recvisition
SELECT
   @tdoc                 = g.TDOC_ID             ,
   @SUPPLIER_ID          = g.ENTERPRISE_ID       ,
   @SELFENTER_ID         = g.SELFENTER_ID        ,
   @DOCUM_DATE           = g.DOCUM_DATE          ,
   @CURR_HOME            = g.DOCUM_HOME_CURR     ,
   @CURR_MAIN            = g.DOCUM_MAIN_CURR     ,
   @DOC_EXT_RATE_TO_MAIN = g.DOC_EXT_RATE_TO_MAIN,
   @DOC_EXT_RATE_TO_HOME = g.DOC_EXT_RATE_TO_HOME,
   @DOCUM_TAX_PROCENT    = g.DOCUM_TAX_PROCENT   ,
   @AGREE_ID             = g.AGREE_ID            ,
   @DOCUM_NUMB_P         = g.DOCUM_NUMB
 FROM  dbo.SALE g
 WHERE ( g.DOCUM_ID = @BILL_ID)

IF @DOCUM_TAX_PROCENT IS NULL
  SELECT @DOCUM_TAX_PROCENT = CAST(CONST_VALUE AS money) 
    FROM CONSTANTS WHERE CONST_ID = 'TaxBase'
-- docum number
/*  exec GET_COUNTER_NEXT
	  @TYPE_DOC = 4,
          @SELF_ID = @SELFENTER_ID,
	  @P3 = @DOCUM_NUMB OUTPUT
*/
  exec @DocErr = CREATE_DOC_FOREIGN
                    @SELFENTER_ID         = @SELFENTER_ID,
                    @AGREE_ID             = @AGREE_ID,
                    @TDOC_ID              = 4,
                    @DOCUM_NUMB           = '',  -- 2.10.2000 vkk
                    @DOCUM_DATE           = @DOCUM_DATE,
                    @DOCUM_HOME_CURR      = @CURR_HOME,
                    @DOCUM_MAIN_CURR      = @CURR_MAIN,
                    @DOC_EXT_RATE_TO_MAIN = @DOC_EXT_RATE_TO_MAIN,
                    @DOC_EXT_RATE_TO_HOME = @DOC_EXT_RATE_TO_HOME,
                    @DOCUM_TAX_PROCENT    = @DOCUM_TAX_PROCENT,
                    @DOCUM_STATE          = 3,
                    @DOCUM_ID             = @DocId OUTPUT
  IF (@DocErr <> 0)
      BEGIN
        SET @DocErr = 100 + @DocErr
        GOTO End_Of_Doc
      END
  SET @VAT_ID = @DocId

DECLARE @ds VARCHAR(40)

SET DATEFORMAT dmy
SET @ds = convert(varchar(15), @DOCUM_DATE, 104)

DECLARE @td VARCHAR(250)

--select @td = TDOC_NAME from type_doc where TDOC_ID = @tdoc
set @td = ''

---------    =---------------------------
declare @VATtype int
if(@DOCUM_TAX_PROCENT = 20) set @VATtype = 0
if(@DOCUM_TAX_PROCENT = 0) set @VATtype = 3

update INVOICE_TAX 
set  
        ENTERPRISE_ID = @SUPPLIER_ID,
        INVTAX_TYPE = @VATtype ,
        DOCUM_TAX_PROCENT = @DOCUM_TAX_PROCENT,
--        DOCUM_BASIS =  @td +  '  '+ LEFT(@docum_numb,@pre) + '  ' + @ds
        DOCUM_BASIS ='  '+ ltrim(rtrim(@docum_numb_p)) + '  ' + @ds + '.'
where DOCUM_ID = @DocId


--*<><><><><><><><><><><><><><><>< LINE ><><><><><><><><><><><><><><><><><><><><>*--

DECLARE
 @tLINE_NUMBER                    INT,
 @tLINE_TYPE                      T_LINE_SP_TYPE,
 @tLINE_PLU_ID                    T_PLU,
 @tLINE_CNS_ID                    T_CONSIGNMENT,
 @tLINE_IN_OUT                    T_LINE_IN_OUT, 
 @tLINE_NAME                      T_NAME_LONG,
 @tLINE_UNIT                      T_METRIC_ID,
 @tLINE_QUAN                      T_DOCUMENT_QUAN,
 @tLINE_QUAN_DISTRIB              T_DOCUMENT_QUAN,
 @tLINE_LOC_ID                    T_LOCATION_ID,
 @tLINE_DEP_ID                    T_LOCATION_ID,
 @tLINE_SUBDEP_ID                 T_LOCATION_ID,
 @tLINE_SECT_ID                   T_LOCATION_ID,
 @tLINE_PRICE_HOME                T_COST       ,
 @tLINE_PRICEFULL_HOME            T_COST       ,
 @tLINE_DONE                      TINYINT
  DECLARE DocLine_Cursor INSENSITIVE CURSOR FOR
    SELECT g.LINE_DONE, g.LINE_TYPE, g.LINE_PLU_ID, g.LINE_CNS_ID, g.LINE_IN_OUT, g.LINE_NAME, g.LINE_UNIT,
           g.LINE_QUAN, g.LINE_QUAN_DISTRIB,
           g.LINE_LOC_ID, g.LINE_DEP_ID, g.LINE_SUBDEP_ID, g.LINE_SECT_ID,
             g.LINE_PRICE_HOME, g.LINE_PRICEFULL_HOME      
    FROM dbo.LINE_SALE g
    WHERE (g.DOCUM_ID = @BILL_ID)
    ORDER BY g.LINE_NUMBER


  SET @tLINE_NUMBER = 0
  OPEN DocLine_Cursor
  FETCH NEXT FROM DocLine_Cursor 
     INTO  @tLINE_DONE, @tLINE_TYPE, @tLINE_PLU_ID, @tLINE_CNS_ID, @tLINE_IN_OUT, @tLINE_NAME, @tLINE_UNIT,
           @tLINE_QUAN, @tLINE_QUAN_DISTRIB,
           @tLINE_LOC_ID, @tLINE_DEP_ID, @tLINE_SUBDEP_ID, @tLINE_SECT_ID,
                 @tLINE_PRICE_HOME, @tLINE_PRICEFULL_HOME                 


  WHILE @@FETCH_STATUS = 0
  BEGIN

  IF NOT EXISTS (
    SELECT LINE_PLU_ID
      FROM LINE_INVOICE_TAX
      WHERE ((DOCUM_ID = @DocId) and (LINE_PLU_ID = @tLINE_PLU_ID) and (LINE_PRICE_HOME =@tLINE_PRICE_HOME )))
    BEGIN

    SET @tLINE_NUMBER = @tLINE_NUMBER + 1

        INSERT INTO LINE_INVOICE_TAX
           ( DOCUM_ID              , LINE_NUMBER           ,
             LINE_TYPE             , LINE_PLU_ID           ,
             LINE_IN_OUT           , LINE_NAME             ,
             LINE_UNIT             , LINE_QUAN             ,
             LINE_PRICE_HOME       ,
             LINE_PRICEFULL_HOME   ,
             LINE_DONE             , 
             LINE_LOC_ID           ,
             LINE_DEP_ID           , LINE_SUBDEP_ID        ,
             LINE_SECT_ID       , line_cns_id
                )
        VALUES
           (@DocId   , @tLINE_NUMBER ,
            0                      , @tLINE_PLU_ID   ,
            @tLINE_IN_OUT, @tLINE_NAME, 
            @tLINE_UNIT,           @tLINE_QUAN, 
                 isnull(@tLINE_PRICE_HOME,0)                 ,
                 isnull(@tLINE_PRICEFULL_HOME,0)             ,
             0, 
           @tLINE_LOC_ID, @tLINE_DEP_ID, @tLINE_SUBDEP_ID, @tLINE_SECT_ID,
           @tLINE_CNS_ID

         )

    IF (@@ERROR <> 0) OR (@DocErr < 0)
      BEGIN
      SET @DocErr = 300 + @DocErr
      BREAK
      END
  END
   else                 
        UPDATE LINE_INVOICE_TAX
           set
             LINE_QUAN       =  LINE_QUAN   + isnull(@tLINE_QUAN,0)         
          WHERE (DOCUM_ID = @DocId) and (LINE_PLU_ID = @tLINE_PLU_ID) and (LINE_PRICE_HOME =@tLINE_PRICE_HOME )

  FETCH NEXT FROM DocLine_Cursor 
     INTO  @tLINE_DONE, @tLINE_TYPE, @tLINE_PLU_ID, @tLINE_CNS_ID, @tLINE_IN_OUT, @tLINE_NAME, @tLINE_UNIT,
           @tLINE_QUAN, @tLINE_QUAN_DISTRIB,
           @tLINE_LOC_ID, @tLINE_DEP_ID, @tLINE_SUBDEP_ID, @tLINE_SECT_ID,
                 @tLINE_PRICE_HOME, @tLINE_PRICEFULL_HOME                 
  END
  CLOSE DocLine_Cursor
  DEALLOCATE DocLine_Cursor


  exec @DocErr = CALC_SUMM_INVOICE_TAX
    @DOCUM_ID          = @DocId,
    @DOCUM_TAX_PROCENT = @DOCUM_TAX_PROCENT,
    @DOCUM_HOME_CURR   = @CURR_HOME,
    @DOCUM_MAIN_CURR   = @CURR_MAIN


  IF (@@ERROR <> 0) OR (@DocErr <> 0)
      BEGIN
      SET @DocErr = 400 + @DocErr
      GOTO End_Of_Doc
      END

  IF NOT EXISTS (
    SELECT LINE_PLU_ID
      FROM LINE_INVOICE_TAX
      WHERE DOCUM_ID = @DocId )
    BEGIN
    SET @DocErr = 9
    END
End_Of_Doc:

RETURN @DocErr
----------------------------------------------------------
GO

exec ALTER_RUN @ALT_DATE = '20110124', @ALT_NUMB = 0, @GRANT = 0, @ALT_NOTE = '  '
GO
